#!/usr/bin/tclsh
source sxml.tcl
proc justpostcodes {cstack cdata saved_data cattr saved_attr } {
upvar $saved_data sdata
upvar $saved_attr sattr

	set ll [split $cstack :]
	set last [lindex $ll [expr [llength $ll] - 1]]
	if { "$last" != "postcode" } { return 0 } 
	puts [format "%-40s: %s" "Current stack:" [string trim $cstack]]
	puts [format "%-40s: %s" "Current data:" [string trim $cdata]]
	puts [format "%-40s: %s" "Current attributes:" [string trim $cattr]]
	foreach x [lsort [array names sdata]] {
		if { "$x" == "_dummy_" } continue
		puts [format "%-40s: %s (%s)" $x [string trim $sdata($x)] [string trim $sattr($x)]]
	}
	puts ""
	return 0
}

set id [sxml::init addrtest.xml]
if { $id == -1 } {
	puts "Error: Unable to parse test file!"
	exit 1
}

sxml::register_routine $id "_default_" justpostcodes
set x [sxml::parse $id]
sxml::end $id
if { $x != 0 } {
	puts "Invalid XML file! ($x)"
	exit 1
}
exit 0
